using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.FcBusinesses;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses
{
    public interface IOutboundStatisticRepository
    {
        Task<BaseResult> Add(OutboundStatisticElastic OutboundStatistic);
        Task<BaseResult> AddManyAsync(IEnumerable<OutboundStatisticElastic> OutboundStatistics);
        Task<BulkResponse> DeleteOutboundStatistics(IEnumerable<OutboundStatisticElastic> OutboundStatistics);
        Task<DeleteByQueryResponse> DeleteOutboundStatisticsByQuery(IEnumerable<long> ids);
        Task<SmartTableResult<OutboundStatisticElastic>> SearchForExcel(BoolQueryDescriptor<OutboundStatisticElastic> query);

    }
    public class OutboundStatisticRepository : IOutboundStatisticRepository
    {
        private readonly ElasticIndex<OutboundStatisticElastic> _dbContext;

        public OutboundStatisticRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<OutboundStatisticElastic>(settings.Value.ClusterUrl, "fcbusinessoutboundstatistic");
        }

        #region  search

        public async Task<SmartTableResult<OutboundStatisticElastic>> SearchForExcel(BoolQueryDescriptor<OutboundStatisticElastic> query)
        {
            return await _dbContext.Search(query);
        }

        #endregion

        #region Add order

        public async Task<BaseResult> Add(OutboundStatisticElastic OutboundStatistic)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(OutboundStatistic);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<OutboundStatisticElastic> OutboundStatistics)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(OutboundStatistics);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteOutboundStatistics(IEnumerable<OutboundStatisticElastic> OutboundStatistics)
        {
            return await _dbContext.DeleteMany(OutboundStatistics);
        }

        public async Task<DeleteByQueryResponse> DeleteOutboundStatisticsByQuery(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        #endregion
    }
}
